//
//  FakeDragViewUser.mm
//  fakedragger
//
//  Created by Geoff Beier on 11/29/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import "FakeDragViewUser.h"

#include <Carbon/Carbon.h>

@interface PhonyView : NSView {
  NSPasteboard * m_pboard;
  NSImage * m_dragimage;
}
-(void)setPasteboard:(NSPasteboard *)aPasteboard;
-(void)setDragImage:(NSImage *)anImage;
-(void)initiateDrag;
@end

NSImage * sImage = nil;

@interface FakeDragViewUser(PRIVATE)
+(BOOL)loadImage;
@end

@implementation FakeDragViewUser

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
      if(!sImage && ![FakeDragViewUser loadImage]) {
        return nil;
      }
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
  [sImage compositeToPoint:rect.origin operation:NSCompositeSourceOver];
}

+ (BOOL)loadImage
{
  if(!sImage) sImage = [[NSImage imageNamed:@"purtyImage"] retain];
  if(!sImage) NSLog(@"shit.");
  return sImage != nil;
}

- (void)mouseDown:(NSEvent *)theEvent
{
  // since we won't have a real event in nsDragService, this illustrates what we'll need
  // to do to start a drag
  
  // create a fake window the size of the currently active screen
  NSWindow * phonyWindow;
  NSRect contentRect = [[NSScreen mainScreen] frame];
  phonyWindow = [[NSWindow alloc] initWithContentRect:contentRect styleMask:NSBorderlessWindowMask 
                                              backing:NSBackingStoreNonretained defer:NO];
  // add our utility view
  PhonyView * phonyView = [[PhonyView alloc] initWithFrame:contentRect];
  [phonyWindow setContentView:phonyView];
  // hide the window
  [phonyWindow orderOut:nil];
  
  // give the utility view the pasteboard information and the drag image it needs to
  // complete the drag
  NSPasteboard * pboard = [NSPasteboard pasteboardWithName:NSDragPboard];
  [pboard declareTypes:[NSArray arrayWithObject:NSTIFFPboardType] owner:self];
  [pboard setData:[sImage TIFFRepresentation] forType:NSTIFFPboardType];
  [phonyView setPasteboard:pboard];
  [phonyView setDragImage:sImage];
  
  // have it initiate the drag
  [phonyView initiateDrag];
  NSLog(@"initiateDrag returned");
  
  // clean up after ourselves
  [phonyView release];
  [phonyWindow release];  
}

@end

@implementation PhonyView
-(void)setPasteboard:(NSPasteboard *)aPasteboard
{
  m_pboard = aPasteboard;
}
-(void)setDragImage:(NSImage *)anImage
{
  m_dragimage = anImage;
  
}

// this method initiates a drag with the same information that will be available to us
// within nsDragService
-(void)initiateDrag
{
  NSSize imgSize = [m_dragimage size];
  // start the drag with a mouseDown event, 'cause it's easier
  NSSize dragOffset = NSMakeSize(0.0,0.0);
  NSEvent * mdEvent = [NSEvent mouseEventWithType:NSLeftMouseDown location:[NSEvent mouseLocation]
                                    modifierFlags:GetCurrentKeyModifiers() timestamp:nil windowNumber:[[self window] windowNumber] 
                                          context:[NSGraphicsContext currentContext] eventNumber:nil
                                       clickCount:1 pressure:nil];
  // since we don't know the actual location of the image being dragged from here, just drag the middle.
  // we may actually be able to do a little better within gecko...
  NSPoint imgLoc = [mdEvent locationInWindow];
  imgLoc.x -= imgSize.width/2;
  imgLoc.y -= imgSize.height/2;
  // actually initiate the drag, using our fake event
  [self dragImage:m_dragimage at:imgLoc offset:dragOffset event:mdEvent
       pasteboard:m_pboard source:self slideBack:YES];
}

-(void)drawRect:(NSRect)aRect
{
}

- (NSDragOperation)draggingSourceOperationMaskForLocal:(BOOL)isLocal {
  if (isLocal) return NSDragOperationEvery;
  else return NSDragOperationCopy;
}
@end
